import _objectSpread from "@babel/runtime/helpers/esm/objectSpread";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/esm/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
var BASE_CLASS = "sui-MoleculeDropdownList";
var CLASS_HIDDEN = "is-hidden";
var SIZES = {
  SMALL: 'small',
  MEDIUM: 'medium',
  LARGE: 'large'
};

var MoleculeDropdownList =
/*#__PURE__*/
function (_Component) {
  _inheritsLoose(MoleculeDropdownList, _Component);

  function MoleculeDropdownList() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;
    _this.refDropdownList = React.createRef();

    _this.getFocusedOptionIndex = function (options) {
      var currentElementFocused = document.activeElement;
      return Array.from(options).reduce(function (focusedOptionIndex, option, index) {
        if (option === currentElementFocused) focusedOptionIndex = index;
        return focusedOptionIndex;
      }, 0);
    };

    _this.handleKeyDown = function (ev) {
      var key = ev.key;

      var _assertThisInitialize = _assertThisInitialized(_this),
          getFocusedOptionIndex = _assertThisInitialize.getFocusedOptionIndex,
          refDropdownList = _assertThisInitialize.refDropdownList;

      var options = refDropdownList.current.children;
      var numOptions = options.length;

      if (key === 'ArrowDown' || key === 'ArrowUp') {
        var index = getFocusedOptionIndex(options);

        if (index >= 0 || index <= numOptions) {
          if (key === 'ArrowDown' && index < numOptions - 1) options[index + 1].focus();
          if (key === 'ArrowUp' && index > 0) options[index - 1].focus();
        }

        ev.preventDefault();
        ev.stopPropagation();
      }
    };

    return _this;
  }

  var _proto = MoleculeDropdownList.prototype;

  _proto.render = function render() {
    var refDropdownList = this.refDropdownList,
        handleKeyDown = this.handleKeyDown,
        classNames = this.classNames,
        extendedChildren = this.extendedChildren;
    return React.createElement("ul", {
      ref: refDropdownList,
      tabIndex: "0",
      onKeyDown: handleKeyDown,
      className: classNames
    }, extendedChildren);
  };

  _createClass(MoleculeDropdownList, [{
    key: "extendedChildren",
    get: function get() {
      var _this$props = this.props,
          children = _this$props.children,
          value = _this$props.value,
          size = _this$props.size,
          visible = _this$props.visible,
          onSelect = _this$props.onSelect,
          props = _objectWithoutProperties(_this$props, ["children", "value", "size", "visible", "onSelect"]);

      return React.Children.toArray(children).filter(Boolean).map(function (child, index) {
        var valueChild = child.props.value;
        var selected = Array.isArray(value) ? value.includes(valueChild) : value === valueChild;
        return React.cloneElement(child, _objectSpread({}, props, {
          index: index,
          onSelect: onSelect,
          selected: selected
        }));
      });
    }
  }, {
    key: "classNames",
    get: function get() {
      var _cx;

      var _this$props2 = this.props,
          size = _this$props2.size,
          visible = _this$props2.visible;
      return cx(BASE_CLASS, BASE_CLASS + "--" + size, (_cx = {}, _cx[CLASS_HIDDEN] = !visible, _cx));
    }
  }]);

  return MoleculeDropdownList;
}(Component);

MoleculeDropdownList.displayName = 'MoleculeDropdownList';
MoleculeDropdownList.defaultProps = {
  size: SIZES.SMALL,
  onSelect: function onSelect() {}
};
export default MoleculeDropdownList;
export { SIZES as moleculeDropdownListSizes };